std::iter_move(std::reverse_iterator)(3)

NAME
std::iter_move(std::reverse_iterator) - std::iter_move(std::reverse_iterator)

Synopsis
   friend constexpr std::iter_rvalue_reference_t<Iter>
       iter_move( const std::reverse_iterator& i ) noexcept(/* see below (since C++20)
   */);
   Casts the result of dereferencing the adjusted underlying iterator to its associated
   rvalue reference type.
   The function body is equivalent to:
 auto tmp = i.base();
 return std::ranges::iter_move(--tmp);
   This function template is not visible to ordinary unqualified or qualified lookup,
   and can only be found by argument-dependent lookup when std::reverse_iterator<Iter>
   is an associated class of the arguments.

Parameters
   i - a source reverse iterator

Return value
   An rvalue reference or a prvalue temporary.

Complexity
   Constant.

Exceptions
   noexcept specification:
   noexcept(
       std::is_nothrow_copy_constructible_v<Iter> &&
       noexcept(std::ranges::iter_move(--std::declval<Iter&>()))
   )

Example
// Run this code
 #include <iomanip>
 #include <iostream>
 #include <iterator>
 #include <string>
 #include <vector>
 void print(auto const& rem, auto const& v)
 {
     std::cout << rem << '[' << size(v) << "] {";
     for (char comma[]{0, 0}; auto const& s : v)
         std::cout << comma << ' ' << std::quoted(s), comma[0] = ',';
     std::cout << " }\n";
 }
 int main()
 {
     std::vector<std::string> p{"Alpha", "Bravo", "Charlie"}, q;
     print("p", p), print("q", q);
     using RI = std::reverse_iterator<std::vector<std::string>::iterator>;
     for (RI iter{p.rbegin()}, rend{p.rend()}; iter != rend; ++iter)
         q.emplace_back(/* ADL */ iter_move(iter));
     print("p", p), print("q", q);
 }

Possible output:
 p[3] { "Alpha", "Bravo", "Charlie" }
 q[0] { }
 p[3] { "", "", "" }
 q[3] { "Charlie", "Bravo", "Alpha" }

See also
   iter_move casts the result of dereferencing an object to its associated
   (C++20) rvalue reference type
                        (customization point object)
   iter_move casts the result of dereferencing the underlying iterator to
   (C++20) its associated rvalue reference type
                        (function)
   move obtains an rvalue reference
   (C++11) (function template)
   move_if_noexcept obtains an rvalue reference if the move constructor does not
   (C++11) throw
                        (function template)
   forward forwards a function argument
   (C++11) (function template)
   ranges::move moves a range of elements to a new location
   (C++20) (niebloid)
   ranges::move_backward moves a range of elements to a new location in backwards order
   (C++20) (niebloid)

Category:
     * conditionally noexcept